#################################################################################
# Nombre del programa:	EMAH2018_IMPORTAR_DATA.R                                          
# Autor:              	IECA
# Versión:            	1.0
# Última modificación: 	23 diciembre 2019
#                                                                                
# Descripción: 
#	Este programa procesa un fichero de microdatos (md_EMAH018.dat)
#
# Entrada:                                                           
#     - Archivo de microdatos: 	md_EMAH2018.dat
# Salida: 
#     - Archivo de microdatos en formato data.frame de R: md_EMAH2018 
#                                                                                
#################################################################################

####################    Asignación de parámetros    #######################
#Recogemos la ruta del script en la que se encuentra el fichero de microdatos
setwd("C:/Microdatos_EMAH2018_ASCII")
fichero_micro <- "md_EMAH2018.dat"

#################################################################################

assign("flag_num", 0, envir = .GlobalEnv)

atencion = function(mensaje){
  cat(mensaje)
  assign("flag_num", 1, envir = .GlobalEnv)
  
}

####################     INICIO     #########################
start.time <- Sys.time()
cat("\n")
cat("\n Inicio: ")
print.Date(start.time)
t0 <- proc.time()

nombresVarbls <- c("IDP","CLAVE_VIV","DEGURBA","FEH","FEP","CPRO",
                   "SEXO","EDAD","NACIONALIDAD","SUPERFICIE","TIPOLOGIA","UEG6","A_COSTRU","INT_DIST",
                   "FUENTEB1","TRATAB1","SISTEMAB1","HABITOB11","HABITOB12","HABITOB13",
                   "HABITOB14","HABITOB15","HABITOB16","HABITOB17","HABITOB18","HABITOB19",
                   "HABITOB110","BOTELLAB1","LITROB1","ELECTRIB2","SOLARB2","PANELB21",
                   "PANELB22","ENERGIAB21","ENERGIAB22","ENERGIAB23","ENERGIAB24","ENERGIAB25",
                   "CALEB2","SISCALEB2","SISCALEB21","SISCALEB22","SISCALEB23","GASB2",
                   "SISCALEB24","SISCALEB25","SISCALEB26","BOMBASB2","SISCALEB27","SISCALEB28",
                   "OTROSISTB2","SISCALEB29","SISCALEB210","SISCALEB211","SISCALEB212","SISCALEB213",
                   "HABCALEB2","TEMPB22","AIREB2","HABAIREB2","SISAIREB2","TEMPAIREB22","AISLAAB21",
                   "AISLABB21","AISLACB21","AISLADB21","AISLAEB21","ILUMINAAB21","ILUMINABB21",
                   "ILUMINACB21","CONTEB31","CONTEB32","CONTEB33","CONTEB34","CONTEB35","CONTEB36",
                   "FRECAB3","FRECBB3","FRECCB3","FRECDB3","RAZONAB3","RAZONBB3","RAZONCB3","RAZONDB3",
                   "RESIB31","RESIB32","RESIB33","RESIB34","RESIB35","RESIB36","RESIB37","RESIB38",
                   "RESIB39","RESIB310","RESIB311","RESIB312","RESIB313","LUGARESB1","LUGARESB2",
                   "FRIGOB41","FRIGOB42","FRIGOB43","LAVADOB41","LAVADOB42","LAVADOB43","LAVADOB44",
                   "LAVAVAB41","LAVAVAB42","LAVAVAB43","LAVAVAB44","HORNOB41","HORNOB42","HORNOB43",
                   "HORNOB44","COCINAB41","COCINAB42","COCINAB43","COCINAB44","COCINAB45","COCINAB46",
                   "COCINAB47","TEMPAGUAB4","DISPOTELEB4","FRECTELEB4","DISPOORDEB4","FRECORDEB4",
                   "STANDB4","CABLEB4","RUIDOB5","CAUSARUIDOB51","CAUSARUIDOB52","CAUSARUIDOB53",
                   "CAUSARUIDOB54","CAUSARUIDOB55","CAUSARUIDOB56","CAUSARUIDOB57","CAUSARUIDOB58",
                   "OLORB5","CAUSAOLORB51","CAUSAOLORB52","CAUSAOLORB53","CAUSAOLORB54","CAUSAOLORB55",
                   "CAUSAOLORB56","CAUSAOLORB57","CAUSAOLORB59","CAUSAOLORB58",
                   "NTOTALB8","NMAYORB8","TRANSPORTEB61","TRANSPORTEB62","TRANSPORTEB63",
                   "TRANSPORTEB641","TRANSPORTEB642","TRANSPORTEB65","TRANSPORTEB66","TRANSPORTEB67",
                   "VEHICULOB6","NVEHICULOB6","VEHICULOB61","VEHICULOB62","VEHICULOB63","VEHICULOB64",
                   "VEHICULOB65","VEHICULOB66","CAMBIOB6","COMPRAB71","COMPRAB72",
                   "COMPRAB73","COMPRAB74","COMPRAB75","PREOCUPAB7","SITULOCALB7","SITUANDB7","SITUMUNDOB7"
                   ,"PARTICIPAB71","PARTICIPAB72","PARTICIPAB73","PARTICIPAB74","PARTICIPAB75",
                   "TIPHOGARB8","SITUACTUALB8","EMPLEOB8","CNOB8","CNAEB8","NESTUDIOB8","INGRESOB8")

posiciones    <- c(4,10,1,12,12,2,1,1,1,4,1,1,4,1,2,1,2,1,1,1,1,1,1,1,1,1,1,1,2,1,1,2,2,1,1,1,1,1,1,2,
                   2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,
                   2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1,2,2,2,1,2,2,2,1,2,2,2,1,1,1,1,1,1,1,2,
                   1,2,1,2,1,1,1,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,
                   2,2,2,1,1,1,1,1,2,2,2,2,2,2,2,2,2,1,2,2,2,4,1,2)

tipo          <- c("N","A","A","N","N","A","A","A","A","N","A","A","N","A","N","N","N",
                   "N","N","N","N","N","N","N","N","N","N","N","A","N","N","N","N",
                   "N","N","N","N","N","N","N","N","N","N","N","N","N","N","N","N",
                   "N","N","N","N","N","N","N","N","A","N","N","N","A","N","N","N",
                   "N","N","N","N","N","N","N","N","N","N","N","N","N","N","N","N",
                   "N","N","N","N","N","N","N","N","N","N","N","N","N","N","N","N",
                   "N","N","N","N","N","N","N","N","N","N","N","N","N","N","N","N",
                   "N","N","N","N","N","N","N","N","N","N","N","N","N","N","N","N",
                   "N","N","N","N","N","N","N","N","N","N","N","N","N","N","N","N",
                   "N","N","N","N","N","N","N","N","N","N","N","N","N","N","N","N",
                   "N","A","A","N","N","N","N","N","N","N","N","N","N","N","N","N",
                   "N","N","N","N","A","N","N","N","A","N")

tamanio       <- length(nombresVarbls)


# Lectura del fichero de microdatos (MICROD)

  #Capturamos las columnas con su tipo de dato
  tipDatos <- as.vector(sapply(tipo, function(x){
    if(identical(x, "A"))
      "character"
    else{
      if(identical(x, "N"))
        "numeric"
    }
  }
  )
  )
  # Lectura del fichero de microdatos (MICROD), decimales con coma  
  tryCatch((df1 <- read.fwf(file = fichero_micro, widths= posiciones, colClasses=tipDatos)), error=function(e)
    stop(paste("Error. No se encuentra el fichero: ", e, fichero_micro,". Saliendo de la ejecución...", sep = "")))
  
#Aplicamos los nombres de la cabecera del registro
names(df1) <- nombresVarbls
df1$FEH=df1$FEH/100000000
df1$FEP=df1$FEP/100000000
md_EMAH2018 <- df1


#Liberacion de memoria y aclaración de variables 
#Values
rm(flag_num,nombresVarbls,posiciones,tamanio,df1)
rm(tipDatos)


# Mensaje final ##########################################
end.time <- Sys.time()
cat("\n")
cat("\n Fin del proceso de lectura: ")
print.Date(end.time)

TTotal <- proc.time() - t0
tiempo <- TTotal[3]

if(tiempo < 60){
  cat(paste("\n Tiempo transcurrido:", format(round(tiempo, 2), nsmall = 2), "segundos"))
}else{
  if(tiempo< 3600 & tiempo >= 60){
    cat(paste("\n Tiempo transcurrido:", format(round(tiempo/60, 2), nsmall = 2), "minutos"))
  }else{
    cat(paste("\n Tiempo transcurrido:", format(round(tiempo/3600, 2), nsmall = 2), "horas"))
  }
}
